/*
    mdw - md5sums a web resource
    Copyright (C) 2001  colmmacc@redbrick.dcu.ie

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "mdw_aux.h"



/* check if what looks like and MD5 sum can actually be one */
BOOL check_md5(char *string)
{

	/* basic checks */
	if(string==NULL) {
		return FALSE;
	} else if(strlen(string)!=32) {
		return FALSE;
	}

	/* check each char */
	while(*string) {
		if( (*string < 'a' || *string > 'z') &&
		    (*string < '0' || *string > '9') ){
			return FALSE;
		}
		string++;
	}

	
	return TRUE;
}

/* allocate a uri_t struct */
uri_t   *       alloc_uri(void)
{
	uri_t	* ret;

	if((ret=(uri_t *)malloc(sizeof(uri_t)))==NULL) {
		fprintf(stderr,"Out of Memory, exitting\n");
		exit(FALSE);
	}	

	return ret;
}


#ifndef HAVE_STRDUP

/* for systems without  their own strdup */
char	*	strdup(const char *str)
{
	char	*  ret;

	if((ret=(char *)malloc(strlen(str) + 1 ))) {
		strcpy(ret, str);
	}

	return ret;

}

#endif /* HAVE_STRDUP */
