/*
    mdw - md5sums a web resource
    Copyright (C) 2001  colmmacc@redbrick.dcu.ie

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef MDW_HTTP_H
#define MDW_HTTP_H

#include <netdb.h>

/* Use int's as booleans, but we use _shell_ conventions */
#define BOOL	int
#define TRUE 	0
#define FALSE	1
#define UNSET	2

typedef struct _uri_t {
	/* the original unparsed string */
	char		*	uri_string;

	/* sum to match against (if any) */
	char		*	uri_match;

	/* the uri to be requested */
	char		*	uri_request;

	/* the uri hostname for HTTP/1.1 */
	char		*	uri_hostname;
	
	/* was there an error in the retrieval */
	BOOL			uri_error;

	/* the next item in the list */
	struct	_uri_t	*	next;
	
	/* rest is ignored if a proxy is set */

	/* the port to connect() to */
	int			uri_port;

	/* the host to connect() to */
	struct 	hostent *	uri_host;
} uri_t;

/* turn a uri string into a uri_t structure */
uri_t * uri_parse(char * string);

/* handle the http connection  (including redirects)
   and exit at start of content */
int http_request(uri_t * request);

#endif
