/*
    mdw - md5sums a web resource
    Copyright (C) 2001  colmmacc@redbrick.dcu.ie

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include "mdw_arg.h"
#include "mdw_http.h"
#include "mdw_sock.h"
#include "mdw_md5.h"

/* return a 32 char string with the checksum in hex */
static char * MDString(digest)
unsigned char digest[16];
{

	unsigned int  	i;
	static   char	str[33];
	
	/* print each byte in hex */
	for (i = 0; i < 16; i++)
		sprintf(str+(2*i),"%02x", digest[i]);

	return str;
}


int main(int argc, char **argv)
{

	int 		fd;	
	char	*	line;
	char		sum[16];
	MD5_CTX		md5_sum;
	BOOL		mdw_return=TRUE;

	/* parse our arguments */
	mdw_parse_argv(argc,argv);

	/* cycle thru the uri's */
	while(mdw_uri_list!=NULL) {

		/* ignore uri's with errors */
		if(mdw_uri_list->uri_error==FALSE) {

			/* get the file */
			if((fd=http_request(mdw_uri_list))<0) {
				mdw_uri_list->uri_error=TRUE;		
			} else {

				/* checksum the file */				
				MD5Init(&md5_sum);
				while((line=readline(fd))) {
					MD5Update(&md5_sum, line, strlen(line));
				}
				MD5Final(sum, &md5_sum);

				close(fd);
			}
		}

		/* print the info */

		if(mdw_show_url==TRUE) {
			printf("%s ", mdw_uri_list->uri_string);
		}

		if(mdw_show_sum==TRUE) {
			if(mdw_uri_list->uri_error==TRUE) {
				printf("-");
			} else {
				printf(MDString(sum));
			}
			printf(" ");
		}

		if(mdw_show_matched==TRUE) {
			if(mdw_uri_list->uri_error==TRUE) {
				printf("ERROR");
			} else if(mdw_uri_list->uri_match) {
				/* see if the sums match */
				if(!strcmp(mdw_uri_list->uri_match,MDString(sum))) {
					printf("MATCH");
				} else {
					mdw_return=FALSE;
					printf("CHANGED");
				} 
			} else {
				printf("OK");
			}
		}


		if(mdw_show_url==TRUE ||
		   mdw_show_sum==TRUE ||
		   mdw_show_matched==TRUE ) {
			printf("\n");
		}


		/* change the default return val on error */
		if(mdw_uri_list->uri_error==TRUE) {
			mdw_return=FALSE;
		}

		mdw_uri_list=mdw_uri_list->next;

	}


	/* done */
	return mdw_return;
}
