/*
    mdw - md5sums a web resource
    Copyright (C) 2001  colmmacc@redbrick.dcu.ie

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>


#include "mdw_arg.h"
#include "mdw_sock.h"
#include "mdw_http.h"


/*
** functions originally from jerry@redbrick.dcu.ie
** but heavily massacered ;)
**
*/

int writen(int fd, char *ptr, int nbytes)
{
	int nleft, nwritten;

	nleft=nbytes;
	while(nleft >0) {
		nwritten=write(fd, ptr, nleft);
		if(nwritten<=0)
			return(nwritten);

		nleft -= nwritten;
		ptr += nwritten;
	}
	return(nbytes-nleft);
}



char * readline(int fd)
{
	int 			n, rc;
	char 		  	c;
	static char	* 	ptr=NULL;
	static int	  	len=0;


	/* initialise the buffer */
	if(len==0) {
		if((ptr=(char *)malloc(1024))==NULL) {
			fprintf(stderr,"Out of Memory\n");
			exit(FALSE);
		}

		len=1024;
	}



	for(ptr[0]='\0', n=0; /* use break;s */ ;n++) {

		/* line is too big, make buffer bigger */
		if(n>(len-2)) {
			len+=128;
	
			if((ptr=(char *)realloc(ptr, len))==NULL) {
				fprintf(stderr,"Out of Memory\n");
				exit(FALSE);
			}
		}	

		/* add the char */
		if((rc=read(fd, &c, 1))==1) {
			ptr[n]=c;
			if(c=='\n') {
				break;
			}

		} else {
			/* exit */
			if(n==0) {
				return NULL;
			} else {
				ptr[n]='\0';
				return ptr;
			}
		}
	}

	/* terminate the string */
	ptr[n+1]='\0';
	
	
	return ptr;
} 


int connect_uri(uri_t * uri)
{
	int 	fd;
	struct 	sockaddr_in tcp_socket;
	
	/* initialise the socket */
	if((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		fprintf(stderr,"Could not get socket\n");
		return -1;
	}

	memset(&tcp_socket, 0, sizeof(tcp_socket));
	tcp_socket.sin_family = AF_INET;

	/* connect to wherever */
	if(mdw_use_proxy!=TRUE) {
		tcp_socket.sin_addr.s_addr = ((struct in_addr *)(uri->uri_host->h_addr))->s_addr;
		tcp_socket.sin_port = htons(uri->uri_port);
	} else {
		tcp_socket.sin_addr.s_addr = ((struct in_addr *)(mdw_uri_proxy->uri_host->h_addr))->s_addr;
		tcp_socket.sin_port = htons(mdw_uri_proxy->uri_port);
	}	

	/* do the actual connect */
	if(connect(fd, (struct sockaddr *) &tcp_socket, sizeof(tcp_socket)) == -1) {
		if(mdw_use_proxy!=TRUE) {
			fprintf(stderr,"Could not connect to: %s\n", uri->uri_string);
		} else {
			fprintf(stderr,"Could not connect to: %s\n", mdw_uri_proxy->uri_string);
		}
		uri->uri_error=TRUE;
		return -1;
	}


	return fd;
}

